# core/bot.py
#
#

""" basic package for the program. """

__copyright__ = "Copyright 2014 B.H.J Thate"

## IMPORTS

from core.kernel import cfg, cmnds, ctrl
from core.dispatch import Dispatcher
from core.defines import BLA, ENDC
from core.utils import get_name, short_date
from core.kernel import cmnds, ctrl
from core.object import Object

import logging
import socket
import time

## BOTS

class Bot(Dispatcher):

    """ Base Bot class. """

    def __init__(zelf, *args, **kwargs):
        Dispatcher.__init__(zelf, *args, **kwargs)
        zelf.btype = get_name(zelf)
        zelf.channels = []
        zelf.waiting = True
        if "channel" in zelf: zelf.channels.append(zelf.channel)

    def _raw(zelf, *args, **kwargs): pass

    def join_channels(zelf, *args, **kwargs):
        """ join channels. """
        for channel in zelf.channels: zelf.join(channel)

    def join(zelf, *args, **kwargs): pass

    def exit(zelf, *args, **kwargs):
        """ shutdown a bot. """
        pass

    def start(zelf, *args, **kwargs):
        """ start a bot. """
        zelf._status.status = "running"
        zelf.connect()
        while zelf._status.status:
             time.sleep(0.01)
             try: event = zelf.get_event()
             except EOFError: return
             except socket.timeout: zelf.connect() ; time.sleep(5.0) ; continue
             except: raise
             zelf._status.cmnd = event.get_cmnd()
             new = cmnds.dispatch(event)
             if not new: new = ctrl.dispatch(event)
             zelf._state.input = time.time()
             if new: new.wait()
             if zelf._status.status == "once": break
        zelf.ready()
 
    def get_prompt(zelf, *args, **kwargs):
        """ return a prompt. """
        return ""

    def get_event(zelf, *args, **kwargs):
        """ return an event. """
        return Object()

    def connect(zelf, *args, **kwargs):
        """ connect to server. """
        pass

    def announce(zelf, *args, **kwargs):
        """ announce on channels. """
        logging.info("announce %s" % zelf.channels)
        for channel in zelf.channels:
            if not zelf.denied(channel) or zelf.allowed(channel):
                zelf.say(channel, args[0])
                continue
            logging.warn("! ignore %s" % channel)
                   
    def say(zelf, *args, **kwargs):
        """ output channel, txt. """
        zelf._state.output = time.time()
        zelf._target.say(*args, **kwargs)

    def cmnd(zelf, *args, **kwargs):
        """ run a command with provided string. """
        o = Object()
        o._target = zelf
        o.txt = args[0]
        cmnds.dispatch(o)
        ctrl.dispatch(o)
        return o

    def echo(zelf, *args, **kwargs):
        #if cfg.shell: print("%s %s>%s %s" % (short_date(time.ctime(time.time())).split()[1], BLA, ENDC, str(args[0])))
        #else: print(str(args[0]))
        print(str(args[0]))

## TESTBOT

class TestBot(Bot):

    """ Bot used in unittests. """

    channel = "#test"

    def __init__(zelf, *args, **kwargs):
        Bot.__init__(zelf, *args, **kwargs)
        zelf.results = []

    def _raw(zelf, *args, **kwargs):
        zelf.results.append(args[0])

    def check(zelf, *args, **kwargs):
        if args[0] in zelf.results: return True
