# core/udp.py
#
#

""" relay txt through a udp port listener. """

__copyright__ = "Copyright 2014 B.H.J Thate"

## IMPORTS

from core.defaults import cfg_udp
from core.contrib import rijndael
from core.object import Object
from core.utils import error
from core import kernel

import logging
import socket
import queue
import core
import time
import re

crypt = rijndael.rijndael(cfg_udp.seed)

## UDP class

class UDP(Object):

    def __init__(zelf, *args, **kwargs):
        Object.__init__(zelf, *args, **kwargs)
        zelf._status = Object()
        zelf._status.status = "idle"
        zelf._state = Object()
        zelf._state.boot = time.time()
        zelf._state.start = time.time()
        zelf._state.output = time.time()
        zelf._state.input = time.time()
        zelf._sock = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
        zelf._sock.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
        try: zelf._sock.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEPORT, 1)
        except: pass
        zelf._sock.setblocking(1)

    def _listen(zelf):
        zelf._sock.bind((cfg_udp.host, cfg_udp.port))
        logging.warn("listen %s/%s" % (cfg_udp.host, cfg_udp.port)) 
        zelf.ready()
        while zelf._status.status:
            input, addr = zelf._sock.recvfrom(64000)
            input = str(input.rstrip(), "utf-8")
            data = ""
            for i in range(int(len(input)/16)):
                txt = input[i*16:i*16+16]
                try: data += crypt.decrypt(txt)
                except Exception as ex: error() ;  break
            zelf.output(data, addr)

    def output(zelf, input, addr):
        zelf._state.time_out = time.time()
        passwd, text = input.split(" ", 1)
        text = text.replace("\00", "")
        if passwd == cfg_udp.password: kernel.announce(text)

def init(*args, **kwargs):
    kernel = args[0]
    udp = UDP()
    kernel.run.udp = udp
    kernel.workers.put(udp._listen)
